<?php
  include('include.php');


  $ip_id = $_GET['patient_record_id'];

  $sql = "SELECT (pd.id) patient_id, pd.patient_name, pd.gender, pd.blood, pd.dob, pd.mrd_no,
            DATE_FORMAT(opd.dateTime, '%d-%m-%Y %H:%i') admit_date, 
            opd.nurse_charge, opd.bed_charge, opd.ad_amount, opd.bed_id, opd.doc_fee, 
            DATE_FORMAT(opd.discharge_date, '%Y-%m-%d %H:%i') AS discharge_date
          FROM patient_data pd
          JOIN ip_ob_entry_data opd ON opd.patient_id = pd.id
          WHERE opd.id='$ip_id'";

  $result = mysqli_query($conn, $sql);

  if($row = mysqli_fetch_assoc($result)){
    $patient_name = $row['patient_name'];
    $gender       = $row['gender'];
    $mrd          = $row['mrd_no'];
    $blood        = $row['blood'];
    $bed_id       = $row['bed_id'];

    $patient_id = $row['patient_id'];

    $doctor_charge = $row['doc_fee'];
    $dob = $row['dob'];
    $currentDate = new DateTime();
    $dateOfBirth = new DateTime($dob);    
    $age = $currentDate->diff($dateOfBirth)->y;

    $admit_date = $row['admit_date'];

    $nurse_charge = $row['nurse_charge'];
    $bed_charge = $row['bed_charge'];
    $advance_amount = $row['ad_amount'];
    $discharge_date = $row['discharge_date'];
    
    $discharged = 1;
    if($discharge_date == '0000-00-00 00:00') {
      // header('Location: list_today_record_ip.php?per=no');
      $discharged = 0;
    }

  } else {
    header('Location: list_today_record_ip.php');
  }
?>
<!DOCTYPE html>
<html lang="zxx" dir="ltr" class="light">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="">
  <title>IPD Billing</title>
  <link rel="icon" type="image/png" href="<?php echo $main_path; ?>assets/images/logo/favicon.svg">
  <link rel="preconnect" href="https://fonts.googleapis.com/">
  <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css2?family=Inter:wght@300;400;500;600;700;800&amp;display=swap"
    rel="stylesheet">


    <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>

<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>

<link href="<?php echo $main_path; ?>assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" rel="stylesheet" >


  <!-- BEGIN: Theme CSS-->
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/rt-plugins.css">
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/app.css">
  <!-- End : Theme CSS -->

  <!-- Start : theme-store js -->
  <script src="<?php echo $main_path; ?>assets/js/store.js" sync></script>
  <!-- End : theme-store js -->
</head>

<style>
  input::-webkit-outer-spin-button,
  input::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }

  .mandatory::after {
    content: "*";
    color: red;
    padding-left: 5px;
  }

  .table-td{
    text-align:center !important;
  }

  .table-th{
    text-align:center !important;
  }

  #ipd_id,#patient_name,#doctor,#admit_date,#discharge_date,#subtotal,#total_discount,#total_bill,#description{
      font-size:0.875rem !important;
      color:gray;
    }
</style>

<body class=" font-inter dashcode-app" id="body_class">
  <!-- [if IE]> <p class="browserupgrade"> You are using an <strong>outdated</strong> browser. Please <a href="https://browsehappy.com/">upgrade your browser</a> to improve your experience and security. </p> <![endif] -->
  <main class="app-wrapper">
    <!-- BEGIN: Sidebar -->
    <!-- BEGIN: Sidebar -->
    <?php include('sidebar.php'); ?>
    <!-- End: Sidebar -->
    <!-- End: Sidebar -->
    <!-- BEGIN: Settings -->

    <!-- BEGIN: Settings -->
    <!-- Settings Toggle Button -->

    <!-- END: Settings -->

    <!-- End: Settings -->
    <div class="flex flex-col justify-between min-h-screen">
      <div>
        
        <!-- BEGIN: Header -->
        <!-- BEGIN: Header -->
        <?php include('nav.php'); ?>

        <!-- END: Search Modal -->
        <!-- END: Header -->
        <!-- END: Header -->
        <div class="content-wrapper transition-all duration-150 xl:ltr:ml-[248px] xl:rtl:mr-[248px]"
          id="content_wrapper">
          <div class="page-content">
            <div id="content_layout">
              <!-- BEGIN: Breadcrumb -->

              <!-- END: BreadCrumb -->
              <div class="grid xl:grid-cols-1 grid-cols-1 gap-6">
                <!-- Basic Inputs -->
                <div class="card">
                  <header class="card-header noborder d-flex justify-content-between">
                    <h4 class="card-title" style="margin-top:0.75rem;">IPD Billing</h4>     
                    <div class="d-flex gap-4">
                        <a href="javascript:void(0);" onclick="window.open('<?php echo $reception_path; ?>transaction_history.php?ip_id=<?php echo $ip_id; ?>');" class="justify-content-end" style="font-size:25px;">
                          <iconify-icon icon="material-symbols:history" title="View History"></iconify-icon>
                        </a>
                      </div>               
                  </header>
                  <div class="card-body flex flex-col p-6">

                    <div style="display:flex;justify-content:space-between;width:100%;">                   
                      

                    </div>

                    <div class="card-body">
                      <div class="row">

                      <div class="card-body">
                            <div class="row ps-2">

                              <div class="col-lg-6 col-md-2 col-sm-5 col-4">
                                <p class="text1">Patient Name: <span class="text-primary ms-1"><?php echo $patient_name ?></span></p>
                                <p class="mt-2 text1">Gender: <span class="text-primary ms-5"><?php echo $gender ?></span></p>
                                <p class="mt-2 text1">Age: <span class="text-primary" style="margin-left: 70px"><?php echo $age ?></span></p>
                              </div>

                              <div class="col-6">
                                <p class="text1">MRD No: <span  class="text-primary ms-5"><?php echo $mrd ?></span></p>
                                <p class="mt-2 text1">Blood Group: <span  class="text-primary ms-3"><?php echo $blood ?></span></p>
                              </div>

                            </div>
                            
                            <br><br>

                          </div>
                      </div>

                      <div class="row">
                        <div class="col-4">
                          <div class="input-area">
                            <label for="admit_date" class="form-label ">Date (Admit)</label>
                            <div class="relative">
                              <input id="admit_date" class="form-control" value="<?php echo $admit_date ?>" readonly>
                            </div>
                          </div>
                        </div>

                        <div class="col-4">
                          <div class="input-area">
                            <label for="discharge_date" class="form-label ">Date (Discharge)</label>
                            <div class="relative">
                              <input id="discharge_date" class="form-control" value="<?php echo $discharge_date ?>" readonly> 
                            </div>
                          </div>
                        </div>

                        <div class="col-2">
                          <div class="input-area">
                            <label for="days" class="form-label">No. of Days</label>
                            <div class="relative">
                              <input type="text" id="days" class="form-control" readonly>
                            </div>
                          </div>
                        </div>

                        <div class="col-2">
                          <div class="input-area">
                            <label for="time_difference" class="form-label">Time spent</label>
                            <div class="relative">
                              <input id="time_difference" class="form-control" readonly type="text">
                            </div>
                          </div>
                        </div>

                        <!-- <hr> -->
                      <div class="history_heading d-flex justify-content-center mt-4">
                        <h4 class="text-uppercase">Bed history</h4>
                      </div>

                      <table class="min-w-full mb-4 divide-y divide-slate-100 table-fixed dark:divide-slate-700 mt-4" id="bed-history">
                                <thead class="bg-slate-200 dark:bg-slate-700">
                                  <tr>

                                    <th scope="col" class="table-th" style="width:50px;">
                                      #
                                    </th>

                                    <th scope="col" class=" table-th text-right ">
                                      Bed No
                                    </th>

                                    
                                    <th scope="col" class=" table-th text-right ">
                                      Date TIme
                                    </th>
                                    <th scope="col" class=" table-th text-right ">
                                      Price
                                    </th>

                                  </tr>
                                </thead>
                                <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="bed_history_append">
                                </tbody>
                      </table>

                      <hr>

                        <div class="row mb-5">
                                <table class="min-w-full divide-y divide-slate-100 table-fixed dark:divide-slate-700 mt-5">
                                    <thead class="bg-slate-200 dark:bg-slate-700">
                                        <tr>
                                            <th scope="col" style="width:50px;padding-left:10px;padding-right:10px;" class="table-th"></th>
                                            <th scope="col" style="width:80px;" class="table-th">#</th>
                                            <th scope="col" class="table-th">Investigation Name</th>
                                            <th scope="col" class="table-th">Division Name</th>
                                            <!-- <th scope="col" class="table-th">quantity</th> -->
                                            <th scope="col" class="table-th text-right">Payable Amount</th>
                                        </tr>
                                    </thead>
                                    <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="inves_records">
                                    <?php
                                      $select_divison= mysqli_query($conn, "SELECT osd.id, osd.division_id,sc.scan_cat_name, osd.amount, s.scan_name, osd.qty 
                                                                                FROM ip_bill_scan osd
                                                                              JOIN scan_cat sc ON osd.division_id = sc.id
                                                                              JOIN scan s ON sc.scan_id = s.id 
                                                                              WHERE osd.patient_record_id='$ip_id' ");
                                      $count = 1;
                                      while($row = mysqli_fetch_assoc($select_divison)){
                                          $id = $row['id'];
                                          $division_id = $row['division_id'];
                                          $division_name = $row['scan_cat_name'];
                                          $division_price = $row['amount'];
                                          $scan_name = $row['scan_name'];
                                          $existing_qty = $row['qty'];
                                    ?>
                                      <tr class="inves_data">
                                          <td scope="col" class="table-td id-check" data-division-id="<?php echo $division_id; ?>" style="display:flex;justify-content:end;padding-left:10px;padding-right:10px;" ><input type="checkbox" data-id="<?php echo $division_id; ?>" data-row-id="<?php echo $id; ?>" data-amount="<?php echo $division_price; ?>" class="form-check-input" checked disabled></td>
                                          <td scope="col" class="table-td"><?php echo $count; ?></td>
                                          <td scope="col" class="table-td"><?php echo $scan_name; ?></td>
                                          <td scope="col" class="table-td division_name"><?php echo $division_name; ?></td>
                                          <!-- <td scope="col" class="table-td i_qty"><?php echo $existing_qty; ?></td> -->
                                          <td scope="col" class="table-td division_price text-right"><?php echo $division_price; ?></td>
                                      </tr>
                                    <?php
                                    $count++;
                                      }
                                    ?>
                                    </tbody>
                                </table>
                            </div>

                        <hr>

                        <table class="min-w-full divide-y divide-slate-100 table-fixed dark:divide-slate-700 mt-5"
                          id="color-status">
                          <thead class="bg-slate-200 dark:bg-slate-700">
                            <tr>
                              <th scope="col" class=" table-th " style="width:20px;">
                                #
                              </th>
                              <th scope="col" class=" table-th ">
                                Service Name
                              </th>
                              <!-- <th scope="col" class=" table-th ">
                                Quantity
                              </th> -->
                              <th scope="col" class="table-th text-right" style="width:200px;">
                                Charge
                              </th>
                            </tr>
                          </thead>
                          <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="patient_records">
                                  <tr class="s_data">
                                    <td scope="col" class="table-td">1</td>
                                    <td scope="col" class="table-td service_name">Nurse Charge</td>
                                    <!-- <td scope="col" class="table-td s_qty">1</td> -->
                                    <td scope="col" class="table-td text-right service_amount" id="nurse_charge"><?php echo $nurse_charge; ?></td>
                                  </tr>
                                  
                                  <tr class="s_data">
                                    <td scope="col" class="table-td">2</td>
                                    <td scope="col" class="table-td service_name">Bed Charge</td>
                                    <!-- <td scope="col" class="table-td s_qty">1</td> -->
                                    <td scope="col" class="table-td text-right service_amount" id="bed_charge"></td>
                                  </tr>

                                  <tr class="s_data">
                                    <td scope="col" class="table-td">3</td>
                                    <td scope="col" class="table-td service_name">Doctor Charge</td>
                                    <!-- <td scope="col" class="table-td s_qty">1</td> -->
                                    <td scope="col" class="table-td text-right service_amount" id="doc_charge"><?php echo $doctor_charge; ?></td>
                                  </tr>
                                  <?php
                                    $select_services = mysqli_query($conn, "SELECT ibs.service_id, ibs.service_name, ibs.qty, ibs.service_amount 
                                                                            FROM ip_bill_services ibs 
                                                                            WHERE ibs.patient_record_id = '$ip_id' ");
                                    $s_count = 4;

                                    while($service_db_row = mysqli_fetch_assoc($select_services)) {
                                      $service_id = $service_db_row['service_id'];
                                      $service_name = $service_db_row['service_name'];
                                      // $service_qty = $service_db_row['qty'];
                                      $service_amount = $service_db_row['service_amount'];
                                  ?>
                                    <tr class="s_data" data-id="<?php echo $service_id ?>" data-qty="<?php echo $service_qty; ?>">
                                      <td scope="col" class="table-td"><?php echo $s_count++; ?></td>
                                      <td scope="col" class="table-td service_name"><?php echo $service_name ?></td>
                                      <!-- <td scope="col" class="table-td s_qty"><?php echo $service_qty; ?></td> -->
                                      <td scope="col" class="table-td text-right service_amount"><?php echo $service_amount; ?></td>
                                    </tr>
                                  <?php
                                    }
                                  ?>

                          </tbody>
                        </table>
                      </div>


                      <div class="modal fade" id="addItem" tabindex="-1" role="dialog" aria-labelledby="addItem"
                        aria-hidden="true">
                        <div class="modal-dialog modal-lg" role="document">
                          <div class="modal-content">
                            <div class="modal-body ">

                              <div class="d-flex justify-content-between mt-2">
                                <div class="col-12">
                                  <div class="input-area">
                                    <div class="relative d-flex gap-2">
                                      <iconify-icon icon="material-symbols:search" class="mt-2" style="font-size: 24px;">
                                      </iconify-icon>
                                      <input type="text" id="search" class="form-control" placeholder="Search by Service">
                                    </div>
                                  </div>
                                </div>

                                <!-- <div>
                                  <button class="btn btn-sm btn-primary" data-toggle="modal" data-target="#addService">
                                    Add Service
                                  </button>
                                </div> -->

                              </div>

                              <table class="min-w-full divide-y divide-slate-100 table-fixed dark:divide-slate-700 mt-4"
                                id="color-status">
                                <thead class="bg-slate-200 dark:bg-slate-700">
                                  <tr>

                                    <th scope="col" class="table-th" style="width:50px;">
                                      #
                                    </th>

                                    <th scope="col" class=" table-th ">
                                      Service Name
                                    </th>

                                    <!-- <th scope="col" class=" table-th ">
                                      Quantity
                                    </th> -->

                                    <th scope="col" class=" table-th text-right ">
                                      Charge
                                    </th>

                                  </tr>
                                </thead>
                                <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="append_item">
                                </tbody>
                              </table>
                            </div>
                            <div style="display:flex;justify-content:end;">
                              
                            <button class="btn btn-sm btn-primary mt-4 m-3" id="cancel_btn" data-bs-dismiss="modal">
                                <div class="d-flex">
                                    <!-- <iconify-icon icon="mdi:cancel" style="font-size:15px;"></iconify-icon> -->
                                    <span class="ms-1">Cancel</span>
                                </div>
                            </button>

                              <button class="btn btn-sm btn-success mt-4 m-3" id="submit">
                                <div class="d-flex">
                                  <!-- <iconify-icon icon="mdi:tick" style="font-size:15px;">
                                  </iconify-icon>  -->
                                  <span class="ms-1">Submit</span>
                                </div>
                              </button>

                            </div>
                          </div>
                        </div>
                      </div>


                      <div class="modal fade" id="addves" tabindex="-1" role="dialog" aria-labelledby="addves"
                        aria-hidden="true">
                        <div class="modal-dialog modal-lg" role="document">
                          <div class="modal-content">
                            <div class="modal-body ">

                              <div class="d-flex justify-content-between mt-2">
                                <div class="col-12">
                                  <div class="input-area">
                                    <div class="relative d-flex gap-2">
                                      <iconify-icon icon="material-symbols:search" class="mt-2" style="font-size: 24px;">
                                      </iconify-icon>
                                      <input type="text" id="search" class="form-control" placeholder="Search by Service">
                                    </div>
                                  </div>
                                </div>

                                <!-- <div>
                                  <button class="btn btn-sm btn-primary" data-toggle="modal" data-target="#addService">
                                    Add Service
                                  </button>
                                </div> -->
                              </div>

                              <table class="min-w-full divide-y divide-slate-100 table-fixed dark:divide-slate-700 mt-4"
                                id="color-status">
                                <thead class="bg-slate-200 dark:bg-slate-700">
                                  <tr>
                                    <th scope="col" class="table-th" style="width:50px;">
                                      #
                                    </th>
                                    <th scope="col" class=" table-th ">
                                      Investigation
                                    </th>
                                    <th scope="col" class=" table-th ">
                                      Division
                                    </th>
                                    <!-- <th scope="col" class=" table-th ">
                                      Quantity
                                    </th> -->
                                    <th scope="col" class=" table-th text-right ">
                                      Payable Amount
                                    </th>
                                  </tr>
                                </thead>
                                <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="append_inves">
                                </tbody>
                              </table>
                            </div>
                            <div style="display:flex;justify-content:end;">
                              
                            <button class="btn btn-sm btn-primary mt-4 m-3" id="cancel_inves" data-bs-dismiss="modal">
                                <div class="d-flex">
                                    <!-- <iconify-icon icon="mdi:cancel" style="font-size:15px;"></iconify-icon> -->
                                    <span class="ms-1">Cancel</span>
                                </div>
                            </button>

                              <button class="btn btn-sm btn-success mt-4 m-3" id="submit_inves">
                                <div class="d-flex">
                                  <!-- <iconify-icon icon="mdi:tick" style="font-size:15px;">
                                  </iconify-icon>  -->
                                  <span class="ms-1">Submit</span>
                                </div>
                              </button>
                            </div>
                          </div>
                        </div>
                      </div>

                      <!-- <div style="display:flex;justify-content:end;" class="mt-3">
                        <button class="btn btn-sm btn-info text-white mt-4 me-1" data-bs-toggle="modal" data-bs-target="#addves">
                          Add Investigation
                        </button>
                        <button class="btn btn-sm btn-success mt-4" data-bs-toggle="modal" data-bs-target="#addItem">
                          Add Item
                        </button>
                      </div> -->
                     
                    </div>

                    <hr>
                  
                    <div class="row">

                      <div class="col-4">
                        <div class="row">
                          <div class="col-12">
                            <div class="input-area">
                              <label for="total_discount" class="form-label">Less</label>
                              <div class="relative">
                                <input id="total_discount" type="number" class="form-control" placeholder="Enter Less">
                              </div>
                            </div>
                          </div>
                          <div class="col-12">
                            <div class="input-area mt-4">
                              <label for="description" class="form-label">Reason For Less</label>
                              <div class="relative">
                                <textarea id="description" cols="30" rows="3" class="form-control"
                                  placeholder="Reason For Less"></textarea>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>

                      <div class="col-2 mb-4"></div>

                      <div class="col-6">
                        <div class="row">
                          <div class="col-6 mb-3 d-flex justify-content-end align-items-center">
                            Sub Total
                          </div>
                          <div class="col-6 mb-3">
                            <input id="subtotal" type="number" class="form-control text-right" placeholder="Sub Total" readonly>
                          </div>
                          <div class="col-6 mb-3 d-flex justify-content-end align-items-center">
                            Paid Amount
                          </div>
                          <div class="col-6 mb-3">
                          <input id="advance" type="number" class="form-control text-right" placeholder="Advance" value='<?php echo $advance_amount; ?>' readonly>
                          </div>
                          <div class="col-6 mb-3 d-flex justify-content-end align-items-center">
                            Payable Amount
                          </div>
                          <div class="col-6 mb-3">
                            <input id="total_bill"  class="form-control text-right" placeholder="Total Bill" readonly>
                          </div>
                        </div>
                      </div>

                      
                      <div class="row mt-4 mb-4">
                        <div class="col-4">
                          <label for="mop" class="form-label">Mode Of Payment</label>
                          <select name="mop" id="mop" class="form-control" onchange="showTId();">
                            <option value="">--- SELECT MOP ---</option>
                            <option value="Card">Card</option>
                            <option value="Cash">Cash</option>
                            <option value="Online">Online</option>
                          </select>
                        </div>
                        <div class="col-4 d-none"  id="t_m_div">
                          <label for="t_m" class="form-label">Transaction ID</label>
                          <input type="text" name="t_m" id="t_m_id" class="form-control">
                        </div>
                      </div>

                      <div class="row">
                        <div class="col-8">
                          <label for="rem">Remarks</label>
                          <textarea class="form-control" id="t_rem" ></textarea>
                        </div>
                      </div>
                     

                      <div class="col-12 mt-5">
                        <!-- <div class="d-flex justify-content-end">
                          <button class="btn btn-sm btn-primary" id="gen_bill">Generate Bill</button>
                        </div>
                      </div> -->

                        <div class="col-12 mt-5">
                          <div class="d-flex justify-content-end">
                            <button class="btn btn-sm btn-primary" id="gen_pre_bill">Generate Preliminary Bill</button>
                          </div>
                        </div>

                      
                    </div>

                    <div class="row">
                      
                    </div>

                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- BEGIN: Footer For Desktop and tab -->
      <!-- <footer id="footer">
        <div
          class="site-footer px-6 bg-white dark:bg-slate-800 text-slate-500 dark:text-slate-300 py-4 ltr:ml-[248px] rtl:mr-[248px]">
          <div class="grid md:grid-cols-2 grid-cols-1 md:gap-5">
            <div class="text-center ltr:md:text-start rtl:md:text-right text-sm">
              COPYRIGHT ©
              <span id="thisYear"></span>
              DashCode, All rights Reserved
            </div>
            <div class="ltr:md:text-right rtl:md:text-end text-center text-sm">
              Hand-crafted &amp; Made by
              <a href="https://codeshaper.net/" target="_blank" class="text-primary-500 font-semibold">
                Codeshaper
              </a>
            </div>
          </div>
        </div>
      </footer> -->
      <!-- END: Footer For Desktop and tab -->
     
  </main>
  <!-- scripts -->

  <script src="<?php echo $main_path; ?>assets/js/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/rt-plugins.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/app.js"></script>

  <!-- Bootstrap CSS -->

  <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>

<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>

<link href="<?php echo $main_path; ?>assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" rel="stylesheet" >


  <!-- Bootstrap JS and Popper.js -->
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>
<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>


<script src="<?php echo $main_path; ?>assets/toastr/build/toastr.min.js"></script> 

<link rel="stylesheet" href="<?php echo $main_path; ?>assets/toastr/build/toastr.min.css" />
<script>
    var service_row = [];
    var selectedServices = [];
    var filteredServices = [];
    var checkedServiceIds = [];
    var bc = 0;
    var servicesFromDb = [];

    function showTId() {
      var mop = $('#mop').val();
      var t_m_id = $('#t_m_div');
      if (mop !== 'Cash') {
          t_m_id.removeClass('d-none').addClass('d-block');
      } else {
          t_m_id.removeClass('d-block').addClass('d-none');
      }
    }


    $(document).ready(function () {
      
      function bedHistory(){
          var patient_record_id = <?php echo $ip_id ?>;
          var fd = new FormData();
          fd.append('id', patient_record_id);
          $.ajax({
            url: 'ajax/ip/ip_bed_history.php',
            type: 'post',
            contentType: false,
            processData: false,
            data: fd,
            success:function(response){
              var result = JSON.parse(response);
              var data = result.data;
              var bh_html;
              var bh_div = $('#bed_history_append');
              bh_div.empty();

              if(result.status == 'Success'){
                var count = 1;
                data.map(function(item){
                  bh_html = `<tr>
                              <td class="table-td">${count}</td>
                              <td class="table-td">${item.bed_name}</td>
                              <td class="table-td">${item.dateTime}</td>
                              <td class="table-td">${item.price}</td>
                            </tr>`;

                  bh_div.append(bh_html);
                  count++;
                  bc += parseFloat(item.price);
                })
                $('#bed_charge').append(bc);
                calculateDaysAndTime(bc);
              }
            }
          })
        } bedHistory();

      $('#confirm').click(function () {
        $('#addService').modal('hide');
      });

      // document.getElementById('discharge_date').value = getCurrentDateTime();

      function getCurrentDateTime() {
            const now = new Date();
            const year = now.getFullYear();
            const month = (now.getMonth() + 1).toString().padStart(2, '0');
            const day = now.getDate().toString().padStart(2, '0');
            const hours = now.getHours().toString().padStart(2, '0');
            const minutes = now.getMinutes().toString().padStart(2, '0');

            return `${year}-${month}-${day}T${hours}:${minutes}`;

        }

        function calculateDaysAndTime(bc1) {
          // var admitDateStr = $('#admit_date').val();
          // var dischargeDateStr = $('#discharge_date').val();
          // console.log(dischargeDateStr);
          // var admitDate = new Date(admitDateStr.replace(/(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2})/, "$2/$1/$3 $4:$5"));
          // var dischargeDate = new Date(dischargeDateStr);

          var admitDateStr = $('#admit_date').val();
          var dischargeDateStr = $('#discharge_date').val();
          console.log(dischargeDateStr);

          var admitDate = new Date(admitDateStr.replace(/(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2})/, "$2/$1/$3 $4:$5"));
          var dischargeDate;

          // Check if dischargeDateStr is "0000-00-00 00:00"
          if (dischargeDateStr === "0000-00-00 00:00") {
              dischargeDate = new Date(); // Set dischargeDate to the current date and time
          } else {
              dischargeDate = new Date(dischargeDateStr.replace(/(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2})/, "$2/$1/$3 $4:$5"));
          }

          if (dischargeDate < admitDate) {
              toastr.error('Discharge date cannot be before Admit date');
              $('#discharge_date').val(getCurrentDateTime());
              return; 
          }

          var timeDiff = dischargeDate - admitDate;
          var days = Math.floor(timeDiff / (1000 * 60 * 60 * 24)) || 0;
          var remainingTimeInSeconds = Math.floor(timeDiff / 1000);
          var hours = Math.floor(remainingTimeInSeconds / 3600) || 0 ;
          var minutes = Math.floor((remainingTimeInSeconds % 3600) / 60) || 0 ;
          var t_diff = hours + 'h ' + minutes + 'm ';
          $('#days').val(days);
          $('#time_difference').val(t_diff);

          var hoursSpent = hours + (minutes / 60); // Convert minutes to fraction of an hour
          var increment = 6.25; // 6 hours and 15 minutes in terms of hours
          var nurseCharge = (Math.ceil(hoursSpent / increment) * <?php echo $nurse_charge ?>).toFixed(2);
          console.log(nurseCharge);
          console.log(<?php echo $nurse_charge ?>);
          $('#nurse_charge').text(nurseCharge);

          var bcrge = (Math.ceil(hoursSpent / increment) * bc1).toFixed(2);
          $('#bed_charge').text(bcrge);


          var doccharge = (Math.ceil(hoursSpent / increment) * <?php echo $doctor_charge ?>).toFixed(2);
          $('#doc_charge').text(doccharge);

          subTotal();
      }


      // $('#discharge_date').change(function(){
      //   calculateDaysAndTime(bc);
      //   subTotal();
      // })

      $('#search').on('input', function () {
        var searchTerm = $(this).val().toLowerCase();
        filterServices(searchTerm);
        updateTable(filteredServices);
      });

      $(document).on('change', '.service_checkbox', function () {
        var serviceId = $(this).data('id');

        if ($(this).prop('checked')) {
          if (!checkedServiceIds.includes(serviceId)) {
            checkedServiceIds.push(serviceId);
          }
        } else {
          var index = checkedServiceIds.indexOf(serviceId);
          if (index !== -1) {
            checkedServiceIds.splice(index, 1);
          }
        }
      });

      function fetchData() {
        $.ajax({
          url: '../admin/ajax/service/ip_service_list.php',
          type: 'get',
          success: function (response) {
            var result = JSON.parse(response);
            if (result.status == 'Success') {
              service_row = result.data;
              filterServices('');
              updateTable(filteredServices);
            }
          },
          error: function (error) {
            console.error('Error fetching data:', error);
          }
        });

        $.ajax({
          url: '../ajax/scan_division_list.php',
          type: 'get', 
          success: function (response) {
            var result = JSON.parse(response);
            if (result.status == 'Success') {
              inves_row = result.data;
              // filterScan('');
              updateInvesTable(inves_row);
            }
          },
          error: function (error) {
            console.error('Error fetching data:', error);
          }
        });
      } 
      fetchData();

      var selected_inves_ids = [];

      $('.id-check input[type="checkbox"]').change(function() {
        var div_id = $(this).data('id');
        
        if ($(this).is(':checked')) {
          selected_inves_ids.push(div_id);
        } else {
          selected_inves_ids = selected_inves_ids.filter(id => id !== div_id);
        }
      });


      function populateSelectedInvesIds() {
        $('.id-check input[type="checkbox"]:checked').each(function() {
          var div_id = $(this).data('id');
          selected_inves_ids.push(div_id);
        });
      }
      populateSelectedInvesIds();

      function populateSelectedServices() {
        servicesFromDb = [];
        $('.s_data').each(function(){
            var s_id = $(this).data('id');
            // var s_qty = $(this).data('qty');
            
            if (typeof s_id !== 'undefined') {

              servicesFromDb.push({
                  s_id: s_id,
                });
                // s_qty: s_qty

            }
        });

      }
      populateSelectedServices();

      function updateInvesTable(data){
        var append_inves = $('#append_inves');
        var checkInvesHtml = '';

        data.map(function (item){
          var isInvesChecked = selected_inves_ids.includes(parseInt(item.id));
        
          checkInvesHtml += `<tr>
                              <td scope="col" class="table-td">
                                  <div class="input-area">
                                      <div class="relative">
                                          <input class="form-check inves_checkbox" type="checkbox" data-id='${item.id}' ${isInvesChecked ? 'checked' : ''}>
                                      </div>
                                  </div>
                              </td>
                              <td scope="col" class="table-td inves_scan_name">${item.scan_name}</td>
                              <td scope="col" class="table-td inves_scancat_name">${item.scan_cat_name}</td>
                             
                              <td scope="col" class="table-td inves_amount" data-price="${item.price}">${item.price}</td>
                            </tr>`;

                            // <td scope="col" class="table-td inves_qty">
                            //       <div class="quantity-control flex">
                            //           <button class="btn btn-sm btn-secondary decrease-btn" type="button">-</button>
                            //           <input type="number" class="form-control quantity-input" style="width:50px;" data-id="${item.id}" value="1" min="1">
                            //           <button class="btn btn-sm btn-secondary increase-btn" type="button">+</button>
                            //       </div>
                            //   </td>
        })
        append_inves.append(checkInvesHtml);

      }

    //   $(document).on('click', '.increase-btn', function() {
    //       var inputField = $(this).siblings('.quantity-input');
    //       var currentValue = parseInt(inputField.val());
    //       inputField.val(currentValue + 1).trigger('change');
    //   });

    //   $(document).on('click', '.decrease-btn', function() {
    //       var inputField = $(this).siblings('.quantity-input');
    //       var currentValue = parseInt(inputField.val());
    //       if (currentValue > 1) {
    //           inputField.val(currentValue - 1).trigger('change');
    //       }
    //   });

      
    //   $(document).on('change', '.quantity-input', function() {
    //     var itemId = $(this).data('id');
    //     var newQuantity = parseInt($(this).val());
        
    //     var priceCell = $(this).closest('tr').find('.inves_amount');
    //     var og_price = parseFloat(priceCell.data('price'));

    //     var totalAmount = newQuantity * og_price;

    //     priceCell.text(totalAmount.toFixed(2));
    // });


      var checkedModalInves = [];
      $('#submit_inves').on('click', function(){

        checkedModalInves.length = 0;
        $('.inves_checkbox:checked').each(function() {
            var id = $(this).data('id');
            var inves_scan_name = $(this).closest('tr').find('.inves_scan_name').text();
            var inves_scancat_name = $(this).closest('tr').find('.inves_scancat_name').text();
            // var inves_qty = $(this).closest('tr').find('.quantity-input').val();
            var inves_amount = parseFloat($(this).closest('tr').find('.inves_amount').text());

            checkedModalInves.push({
                id: id,
                scan_name: inves_scan_name,
                scan_cat_name: inves_scancat_name,
                amount: inves_amount
            });
        });
        // inves_qty: inves_qty,


        var patient_records = $('#inves_records');
        patient_records.html('');
        checkedModalInves.forEach(function(division, index) {
            index += 0
            var invesHtml = `<tr class="inves_data">
                            <td scope="col" class="table-td id-check" style="display:flex;justify-content:end;padding-left:10px;padding-right:10px;" >
                              <input type="checkbox" data-id="${division.id}" data-amount="${division.amount}" class="form-check-input" checked disabled>
                            </td>
                            <td scope="col" class="table-td">${index + 1}</td>
                            <td scope="col" class="table-td scan_name">${division.scan_name}</td>
                            <td scope="col" class="table-td division_name">${division.scan_cat_name}</td>
                            <td scope="col" class="table-td text-right division_price">${division.amount}</td>
                        </tr>`;

                        // <td scope="col" class="table-td i_qty">${division.inves_qty}</td>

            patient_records.append(invesHtml);
        });

        subTotal();

        $('#cancel_inves').click();

      })

        function filterServices(searchTerm) {
          filteredServices = service_row.filter(item =>
            item.service_name.toLowerCase().includes(searchTerm)
          );
        }

        function updateTable(data) {
          var append_spot = $('#append_item');
          var checkBoxHtml = '';

          data.map(function (item) {
              var isChecked = checkedServiceIds.includes(item.id) || selectedServices.some(service => service.id === item.id) ||servicesFromDb.some(service => service.s_id === item.id);

              var service_type = item.type;
              var amount_td;

              if (service_type == 'variable') {

                  amount_td = `<td scope="col" class="table-td text-right">
                                    <input class="form-control modal_amount" data-id="${item.id}" value="${item.amount}" data-price="${item.amount}" type="number">
                                  </td>`;

              } else {
                  amount_td = `<td scope="col" class="table-td text-right modal_amount" data-id="${item.id}" data-price="${item.amount}">${item.amount}</td>`;
              }

              checkBoxHtml += `<tr>
                                      <td scope="col" class="table-td">
                                          <div class="input-area">
                                              <div class="relative">
                                                  <input class="form-check service_checkbox" type="checkbox" data-id='${item.id}' ${isChecked ? 'checked' : ''}>
                                              </div>
                                          </div>
                                      </td>
                                      <td scope="col" class="table-td modal_name">${item.service_name}</td>
                                     
                                      ${amount_td}
                                    </tr>`;

                                    // <td scope="col" class="table-td inves_qty">
                                    // <div class="ser-quantity-control flex">
                                    //                                         <button class="btn btn-sm btn-secondary decrease-btn" type="button">-</button>
                                    //                                         <input type="number" class="form-control ser-quantity-input" style="width:50px;" data-id="${item.id}" min="1">
                                    //                                         <button class="btn btn-sm btn-secondary increase-btn" type="button">+</button>
                                    //                                     </div>
                                    //                                 </td>


          });
          append_spot.html(checkBoxHtml);
          
          $('.service_checkbox').each(function () {
            var serviceId = $(this).data('id');
            var matchingService = servicesFromDb.find(service => service.s_id === serviceId);
            
            // if (matchingService) {
            //     $(this).prop('checked', true);

            //     var quantity = matchingService.s_qty !== '' ? matchingService.s_qty : 1;
            //     $(this).closest('tr').find('.ser-quantity-input').val(quantity);
            // } else {
            //     $(this).closest('tr').find('.ser-quantity-input').val(1);
            // }
          });


      }

      // $(document).on('click', '.increase-btn', function() {
      //     var inputField = $(this).siblings('.ser-quantity-input');
      //     var currentValue = parseInt(inputField.val());
      //     inputField.val(currentValue + 1).trigger('change');
      // });

      // $(document).on('click', '.decrease-btn', function() {
      //     var inputField = $(this).siblings('.ser-quantity-input');
      //     var currentValue = parseInt(inputField.val());
      //     if (currentValue > 1) {
      //         inputField.val(currentValue - 1).trigger('change');
      //     }
      // });

     

      $('#submit').on('click', function () {
        var checkedServices = [];

        var totalAmount = 0;

        $('.service_checkbox:checked').each(function() {
            var id = $(this).data('id');
            var serviceName = $(this).closest('tr').find('.modal_name').text();
            // var qty = $(this).closest('tr').find('.ser-quantity-input').val();

            var amount;

            var $amountElement = $(`.modal_amount[data-id='${id}']`);
            if ($amountElement.is('input')) {
                amount = parseFloat($amountElement.val());
            } else {
                amount = parseFloat($amountElement.text());
            }

            var serviceTotal = 1 * amount;
            var formatted_amount = serviceTotal.toFixed(2);
            // totalAmount += serviceTotal;

            checkedServices.push({
                id: id,
                name: serviceName,
                amount: formatted_amount,
            });
        });
        // qty: qty,



        var service_record_table = $('#patient_records');
        service_record_table.find('tr:gt(2)').remove();
        checkedServices.forEach(function(service, index) {
            index += 3
            var trHtml = `<tr class="s_data" data-id="${service.id}">
                            <td scope="col" class="table-td">${index + 1}</td>
                            <td scope="col" class="table-td service_name">${service.name}</td>
                            <td scope="col" class="table-td text-right service_amount">${service.amount}</td>
                        </tr>`;
                        // <td scope="col" class="table-td s_qty">${service.qty}</td>

            service_record_table.append(trHtml);
        });

        subTotal();
        populateSelectedServices();

        $('#cancel_btn').click();

        // Other actions as needed (e.g., calculating subtotal)
    });

      $('#total_discount').on('input', function () {
          subTotal();
      });

      function subTotal() {
        var serviceAmounts = $('.service_amount');
        var subTotal = 0;

        serviceAmounts.each(function () {
            var amount = parseFloat($(this).text().replace(/[^\d.-]/g, '')) || 0;
            subTotal += amount;
        });

        let inves_amount = 0;
        $('.division_price').each(function(){
          inves_amount = parseFloat($(this).text());
          subTotal += inves_amount;
        })

        var subtotalElement = $('#subtotal');
        subtotalElement.val(subTotal.toFixed(2));

        var advance = parseFloat($('#advance').val()) || 0;
        var less = parseFloat($('#total_discount').val()) || 0;

        var total = (subTotal - advance - less).toFixed(2);

        if (parseFloat(less) > parseFloat(subTotal)) {
            toastr.error('Less cannot exceed the total amount.');
            less = parseFloat(subTotal);
            total = '0.00';

        }
        $('#total_bill').val(total);
      }
      subTotal();

        $('#gen_bill').click(function () {

          var patient_id = <?php echo $patient_id; ?>;
          var patient_record_id = <?php echo $ip_id ?>;
          var subTotal = $('#subtotal').val();
          var total = $('#total_bill').val();
          var less = $('#total_discount').val();
          var desc = $('#description').val();
          var admit_date = $('#admit_date').val();
          var discharge_date = $('#discharge_date').val();
          var nod = $('#days').val();
          var time = $('#time_difference').val();
          var services = [];

          var mop = $('#mop').val();
          var t_m_id = $('#t_m_id').val();
          var t_rem = $('#t_rem').val()

          if(mop == ""){
            toastr.error('Select MOP');
            return;
          }
          
          if(mop !== "Cash" && t_m_id == ""){
            toastr.error("Enter Transaction ID");
            return;
          }
          
          if (t_rem == "") {
            toastr.error("Enter Remark");
            return;
          } 

          $('#patient_records .s_data').each(function () {
              // var s_id = $(this).data('id');
              var service_name = $(this).find(".service_name").text().trim();
              // var qty = $(this).find(".s_qty").text().trim();
              var service_amount = $(this).find(".service_amount").text().trim();

              var service_row = {
                  service_name: service_name,
                  service_amount: service_amount
              };
              // qty: qty,

              services.push(service_row);
          });

          var checkedCheckboxes = $('.id-check input[type="checkbox"]:checked');
          var checkedCheckboxesData = [];
          
          checkedCheckboxes.each(function(index, checkbox) {
              var id = $(checkbox).data('id');
              // var d_qty = parseInt($(checkbox).closest('tr').find('.i_qty').text());
              var amount = $(checkbox).data('amount');

              checkedCheckboxesData.push({ 
                division_id: id,
                amount: amount
              });
              // d_qty: d_qty,

          });

          if (less !== '' && desc === '') {
              toastr.error('Enter Reason for less');
          } else if(parseFloat(less) > parseFloat(subTotal)) {
            toastr.error('Less should not exceed Total');
          
          }else {
              var fd = new FormData();

              fd.append('patient_id', patient_id);
              fd.append('patient_record_id', patient_record_id);
              fd.append('total', total);

              fd.append('less', less);
              fd.append('desc', desc);
              fd.append('subTotal', subTotal);

              fd.append('admit_date', admit_date);
              fd.append('discharge_date', discharge_date);
              fd.append('nod', nod);
              fd.append('time', time);
              fd.append('services', JSON.stringify(services));
              fd.append(`bed_id`, <?php echo $bed_id; ?>);

              fd.append('division_id', JSON.stringify(checkedCheckboxesData));

              fd.append('created_by', '<?php echo $reception_user_id; ?>');
              fd.append('user_type', '<?php echo $user_type; ?>');

              fd.append('mop', mop);
              fd.append('t_m_id', t_m_id);
              fd.append('t_rem', t_rem);

              $.ajax({
                url: 'ajax/ip/ip_billing.php',
                type: 'post',
                contentType: false,
                processData: false,
                data: fd,
                success:function(response){
                  var result = JSON.parse(response);
                  if(result.status == 'Success'){
                    var bill_no = result.bill_no;
                    toastr.success('Patient Discharged');
                    // window.open("ip_bill.php?patient_record_id="+ <?php echo $ip_id; ?>+"&bill_no="+bill_no+"", "_blank");
                    window.open("ip_bill.php?patient_record_id=<?php echo $ip_id; ?>&bill_no=" + bill_no, "_blank");
                    location.href="<?php echo $reception_path ?>list_today_record_ip.php";
                  }
                }

              })
          }
        });

        $('#gen_pre_bill').click(function () {

            var patient_id = <?php echo $patient_id; ?>;
            var patient_record_id = <?php echo $ip_id ?>;
            var subTotal = $('#subtotal').val();
            var total = $('#total_bill').val();
            var less = $('#total_discount').val();
            var desc = $('#description').val();
            var admit_date = $('#admit_date').val();
            var discharge_date = $('#discharge_date').val();
            var nod = $('#days').val();
            var time = $('#time_difference').val();
            var services = [];

            var mop = $('#mop').val();
            var t_m_id = $('#t_m_id').val();
            var t_rem = $('#t_rem').val()

            // if(mop == ""){
            //   toastr.error('Select MOP');
            //   return;
            // }

            // if(mop !== "Cash" && t_m_id == ""){
            //   toastr.error("Enter Transaction ID");
            //   return;
            // }

            // if (t_rem == "") {
            //   toastr.error("Enter Remark");
            //   return;
            // } 

            $('#patient_records .s_data').each(function () {
                // var s_id = $(this).data('id');
                var service_name = $(this).find(".service_name").text().trim();
                // var qty = $(this).find(".s_qty").text().trim();
                var service_amount = $(this).find(".service_amount").text().trim();

                var service_row = {
                    service_name: service_name,
                    service_amount: service_amount
                  };
                  // qty: qty,
                services.push(service_row);
            });

            var checkedCheckboxes = $('.id-check input[type="checkbox"]:checked');
            var checkedCheckboxesData = [];

            checkedCheckboxes.each(function(index, checkbox) {
                var id = $(checkbox).data('id');
                // var d_qty = parseInt($(checkbox).closest('tr').find('.i_qty').text());
                var amount = $(checkbox).data('amount');

                checkedCheckboxesData.push({ 
                  division_id: id,
                  amount: amount
                });
                // d_qty: d_qty,

            });

            // if (less !== '' && desc === '') {
            //     toastr.error('Enter Reason for less');
            // } else if(parseFloat(less) > parseFloat(subTotal)) {
            //   toastr.error('Less should not exceed Total');

            // }else {
                var fd = new FormData();

                fd.append('patient_id', patient_id);
                fd.append('patient_record_id', patient_record_id);
                fd.append('total', total);

                fd.append('less', less);
                fd.append('desc', desc);
                fd.append('subTotal', subTotal);

                fd.append('admit_date', admit_date);
                fd.append('discharge_date', discharge_date);
                fd.append('nod', nod);
                fd.append('time', time);
                fd.append('services', JSON.stringify(services));
                fd.append(`bed_id`, <?php echo $bed_id; ?>);

                fd.append('division_id', JSON.stringify(checkedCheckboxesData));

                fd.append('created_by', '<?php echo $reception_user_id; ?>');
                fd.append('user_type', '<?php echo $user_type; ?>');

                fd.append('mop', mop);
                fd.append('t_m_id', t_m_id);
                fd.append('t_rem', t_rem);
                
                window.open("pre_bill.php?patient_record_id=<?php echo $ip_id; ?>", "_blank");
                location.href="<?php echo $reception_path ?>list_today_record_ip.php";

                // $.ajax({
                //   url: 'ajax/ip/ip_billing.php', 
                //   type: 'post',
                //   contentType: false,
                //   processData: false,
                //   data: fd,
                //   success:function(response){
                //     var result = JSON.parse(response);
                //     if(result.status == 'Success'){
                //       var bill_no = result.bill_no;
                //       toastr.success('Patient Discharged');
                //       window.open("pre_bill.php?patient_record_id=<?php echo $ip_id; ?>&bill_no=" + bill_no, "_blank");
                //     }
                //   }

                // })
            // }
            });
        });
  </script>
</body>

</html>